/* Ofront 1.4 -xtspkaG */

#ifndef DialogClocks__h
#define DialogClocks__h

#include "SYSTEM.h"
#include "Dialogs.h"
#include "Display.h"

typedef
	struct DialogClocks_ItemDesc *DialogClocks_Item;

typedef
	struct DialogClocks_ItemDesc { /* Dialogs_ObjectDesc */
		LONGINT _prvt0;
		char _prvt1[16];
		CHAR name[16];
		CHAR cmd[32];
		CHAR par[32];
		BOOLEAN selected, overlapping;
		Dialogs_Panel panel;
		char _prvt2[1];
	} DialogClocks_ItemDesc;

import void DialogClocks_Item_Copy (DialogClocks_Item c, Dialogs_Object *dup);
import void DialogClocks_Item_Draw (DialogClocks_Item c, INTEGER x, INTEGER y, Display_Frame f);
import void DialogClocks_Item_Handle (DialogClocks_Item c, Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ);
import void DialogClocks_Item_Print (DialogClocks_Item c, INTEGER x, INTEGER y);
typedef
	struct DialogClocks_Time {
		LONGINT timeStamp, dateStamp;
	} DialogClocks_Time;

import void DialogClocks_Item_Redraw (DialogClocks_Item c, Display_Frame f, INTEGER x, INTEGER y, DialogClocks_Time old, DialogClocks_Time new);
#define __DialogClocks_Item_Redraw(c, f, x, y, old, new) __SEND(__TYPEOF(c), 24, void(*)(DialogClocks_Item, Display_Frame, INTEGER, INTEGER, DialogClocks_Time, DialogClocks_Time), (c, f, x, y, old, new))


import DialogClocks_Time DialogClocks_old;

import LONGINT *DialogClocks_ItemDesc__typ;
import LONGINT *DialogClocks_Time__typ;

import void DialogClocks_Insert (void);
import void *DialogClocks__init(void);


#endif
