/* Ofront 1.4 -xtspkaG */

#ifndef DialogElems__h
#define DialogElems__h

#include "SYSTEM.h"
#include "Dialogs.h"
#include "Texts.h"

typedef
	struct DialogElems_ElemDesc *DialogElems_Elem;

typedef
	struct DialogElems_ElemDesc { /* Texts_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
		Dialogs_Panel dialog;
		INTEGER xg, yg;
		LONGINT sw, sh;
		BOOLEAN empty;
	} DialogElems_ElemDesc;



import LONGINT *DialogElems_ElemDesc__typ;

import void DialogElems_Alloc (void);
import void DialogElems_Changed (DialogElems_Elem e);
import void DialogElems_Copy (DialogElems_Elem se, DialogElems_Elem de);
import void DialogElems_Handle (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ);
import void DialogElems_Insert (void);
import void DialogElems_Open (DialogElems_Elem e, Dialogs_Panel p, INTEGER xg, INTEGER yg, BOOLEAN adjust);
import void DialogElems_OpenViewer (DialogElems_Elem e);
import void DialogElems_SetSize (DialogElems_Elem e, LONGINT w, LONGINT h);
import void DialogElems_Update (void);
import void *DialogElems__init(void);


#endif
