/* Ofront 1.4 -xtspkaG */

#ifndef DialogFrames__h
#define DialogFrames__h

#include "SYSTEM.h"
#include "Dialogs.h"
#include "Display.h"

typedef
	struct DialogFrames_FrameDesc *DialogFrames_Frame;

typedef
	struct DialogFrames_FrameDesc { /* Display_FrameDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		INTEGER col;
		Dialogs_Panel panel;
		INTEGER grid;
		LONGINT pat;
	} DialogFrames_FrameDesc;

import void DialogFrames_Frame_Open (DialogFrames_Frame f, Display_Handler handle, Dialogs_Panel p);
import void DialogFrames_Frame_Restore (DialogFrames_Frame f);
#define __DialogFrames_Frame_Open(f, handle, p) __SEND(__TYPEOF(f), 4, void(*)(DialogFrames_Frame, Display_Handler, Dialogs_Panel), (f, handle, p))
#define __DialogFrames_Frame_Restore(f) __SEND(__TYPEOF(f), 6, void(*)(DialogFrames_Frame), (f))

typedef
	struct DialogFrames_GetFrameMsg { /* Display_FrameMsg */
		Dialogs_Panel p;
		DialogFrames_Frame f;
	} DialogFrames_GetFrameMsg;



import LONGINT *DialogFrames_FrameDesc__typ;
import LONGINT *DialogFrames_GetFrameMsg__typ;

import void DialogFrames_FindObject (Dialogs_Object *o, Dialogs_Panel *p);
import void DialogFrames_GetCaretPosition (Dialogs_Panel *p, INTEGER *xpos, INTEGER *ypos);
import void DialogFrames_Handle (Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ);
import void DialogFrames_OpenPanel (CHAR *name, LONGINT name__len, INTEGER x, INTEGER y, Dialogs_Panel *p);
import void DialogFrames_SetCaretAtObject (Dialogs_Object o);
import void *DialogFrames__init(void);


#endif
