/* Ofront 1.4 -xtspkaG */

#ifndef DialogIntSliders__h
#define DialogIntSliders__h

#include "SYSTEM.h"
#include "DialogSliders.h"
#include "Dialogs.h"
#include "Display.h"

typedef
	struct DialogIntSliders_ItemDesc *DialogIntSliders_Item;

typedef
	struct DialogIntSliders_ItemDesc { /* DialogSliders_ItemDesc */
		LONGINT _prvt0;
		char _prvt1[16];
		CHAR name[16];
		CHAR cmd[32];
		CHAR par[32];
		BOOLEAN selected, overlapping;
		Dialogs_Panel panel;
		char _prvt2[2];
		INTEGER sliderdY, delta;
		INTEGER maxValue;
	} DialogIntSliders_ItemDesc;

import LONGINT DialogIntSliders_Item_Arrow (DialogIntSliders_Item s, BOOLEAN down);
import void DialogIntSliders_Item_CheckdY (DialogIntSliders_Item s, INTEGER *dY);
import void DialogIntSliders_Item_Copy (DialogIntSliders_Item s, Dialogs_Object *dup);
import void DialogIntSliders_Item_DrawSlider (DialogIntSliders_Item s, Display_Frame f, BOOLEAN pressed, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER mode);
import void DialogIntSliders_Item_Init (DialogIntSliders_Item s);
import INTEGER DialogIntSliders_Item_MaxValue (DialogIntSliders_Item s);
import void DialogIntSliders_Item_MoveSlider (DialogIntSliders_Item s, Display_Frame f, BOOLEAN pressed, INTEGER dY);
import void DialogIntSliders_Item_PrintSlider (DialogIntSliders_Item s, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
import void DialogIntSliders_Item_TrackScrollBar (DialogIntSliders_Item s, Display_Frame f, INTEGER mx, INTEGER my, SET keys);


import LONGINT DialogIntSliders_minusArrow, DialogIntSliders_plusArrow;

import LONGINT *DialogIntSliders_ItemDesc__typ;

import void DialogIntSliders_Insert (void);
import void *DialogIntSliders__init(void);


#endif
