/* Ofront 1.4 -xtspkaG */

#ifndef DialogRadioButtons__h
#define DialogRadioButtons__h

#include "SYSTEM.h"
#include "Dialogs.h"
#include "Display.h"

typedef
	struct DialogRadioButtons_ItemDesc *DialogRadioButtons_Item;

typedef
	struct DialogRadioButtons_ItemDesc { /* Dialogs_ObjectDesc */
		LONGINT _prvt0;
		char _prvt1[16];
		CHAR name[16];
		CHAR cmd[32];
		CHAR par[32];
		BOOLEAN selected, overlapping;
		Dialogs_Panel panel;
		char _prvt2[1];
		BOOLEAN on;
	} DialogRadioButtons_ItemDesc;

import void DialogRadioButtons_Item_ChangeValue (DialogRadioButtons_Item r, BOOLEAN value);
import void DialogRadioButtons_Item_Copy (DialogRadioButtons_Item r, Dialogs_Object *dup);
import void DialogRadioButtons_Item_Draw (DialogRadioButtons_Item r, INTEGER x, INTEGER y, Display_Frame f);
import void DialogRadioButtons_Item_Handle (DialogRadioButtons_Item r, Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ);
import void DialogRadioButtons_Item_Print (DialogRadioButtons_Item r, INTEGER x, INTEGER y);
#define __DialogRadioButtons_Item_ChangeValue(r, value) __SEND(__TYPEOF(r), 24, void(*)(DialogRadioButtons_Item, BOOLEAN), (r, value))



import LONGINT *DialogRadioButtons_ItemDesc__typ;

import void DialogRadioButtons_Insert (void);
import void *DialogRadioButtons__init(void);


#endif
