/* Ofront 1.4 -xtspkaG */

#ifndef DialogTexts__h
#define DialogTexts__h

#include "SYSTEM.h"
#include "Dialogs.h"
#include "Display.h"
#include "Texts.h"

typedef
	struct DialogTexts_ItemDesc *DialogTexts_Item;

typedef
	struct DialogTexts_ItemDesc { /* Dialogs_ObjectDesc */
		LONGINT _prvt0;
		char _prvt1[16];
		CHAR name[16];
		CHAR cmd[32];
		CHAR par[32];
		BOOLEAN selected, overlapping;
		Dialogs_Panel panel;
		char _prvt2[8];
	} DialogTexts_ItemDesc;

import void DialogTexts_Item_Copy (DialogTexts_Item t, Dialogs_Object *dup);
import void DialogTexts_Item_Draw (DialogTexts_Item t, INTEGER x, INTEGER y, Display_Frame f);
import Texts_Text DialogTexts_Item_GetText (DialogTexts_Item t);
import void DialogTexts_Item_Handle (DialogTexts_Item t, Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
import void DialogTexts_Item_Init (DialogTexts_Item t);
import void DialogTexts_Item_Print (DialogTexts_Item t, INTEGER x, INTEGER y);
import void DialogTexts_Item_RemoveSelection (DialogTexts_Item t);
import void DialogTexts_Item_SetSelection (DialogTexts_Item t, LONGINT beg, LONGINT end);
#define __DialogTexts_Item_GetText(t) __SEND(__TYPEOF(t), 24, Texts_Text(*)(DialogTexts_Item), (t))
#define __DialogTexts_Item_RemoveSelection(t) __SEND(__TYPEOF(t), 25, void(*)(DialogTexts_Item), (t))
#define __DialogTexts_Item_SetSelection(t, beg, end) __SEND(__TYPEOF(t), 26, void(*)(DialogTexts_Item, LONGINT, LONGINT), (t, beg, end))


import void (*DialogTexts_GetParText)(CHAR*, LONGINT , Dialogs_Panel, Texts_Text*);

import LONGINT *DialogTexts_ItemDesc__typ;

import void DialogTexts_Insert (void);
import void *DialogTexts__init(void);


#endif
