/* Ofront 1.4 -xtspkaG */

#ifndef GraphicElems__h
#define GraphicElems__h

#include "SYSTEM.h"
#include "Graphics.h"
#include "Texts.h"

typedef
	struct GraphicElems_ElemDesc *GraphicElems_Elem;

typedef
	struct GraphicElems_ElemDesc { /* Texts_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
		LONGINT SW, SH, PW, PH;
		Graphics_Graph graph;
		INTEGER Xg, Yg;
		BOOLEAN empty;
	} GraphicElems_ElemDesc;



import LONGINT *GraphicElems_ElemDesc__typ;

import void GraphicElems_Alloc (void);
import void GraphicElems_Changed (GraphicElems_Elem E);
import void GraphicElems_Copy (GraphicElems_Elem SE, GraphicElems_Elem DE);
import Graphics_Graph GraphicElems_CopyGraph (Graphics_Graph G);
import void GraphicElems_Handle (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ);
import void GraphicElems_Insert (void);
import void GraphicElems_Open (GraphicElems_Elem E, Graphics_Graph G, INTEGER Xg, INTEGER Yg, BOOLEAN adjust);
import void GraphicElems_OpenViewer (GraphicElems_Elem E);
import void GraphicElems_SetSize (GraphicElems_Elem E, LONGINT w, LONGINT h);
import void GraphicElems_Update (void);
import void *GraphicElems__init(void);


#endif
