/* Ofront 1.4 -xtspkaG */

#ifndef GraphicUtils__h
#define GraphicUtils__h

#include "SYSTEM.h"
#include "Display.h"
#include "Fonts.h"
#include "Texts.h"


import LONGINT GraphicUtils_dUnit, GraphicUtils_pUnit;


import void GraphicUtils_DrawBox (Display_Frame f, BOOLEAN pressed, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER mode);
import void GraphicUtils_DrawMenu (Display_Frame f, Texts_Text menu, INTEGER sc, INTEGER cmd, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER mode, INTEGER *n, INTEGER *lsp, INTEGER *dsc);
import void GraphicUtils_DrawPatternBox (Display_Frame f, BOOLEAN pressed, LONGINT pat, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER pX, INTEGER pY, INTEGER mode);
import void GraphicUtils_DrawString (Display_Frame f, CHAR *s, LONGINT s__len, INTEGER x, INTEGER y, INTEGER w, Fonts_Font fnt, INTEGER mode, INTEGER align, INTEGER *ret);
import INTEGER GraphicUtils_GetStringLength (CHAR *s, LONGINT s__len, Fonts_Font fnt);
import void GraphicUtils_PrintBox (INTEGER x, INTEGER y, INTEGER w, INTEGER h);
import void GraphicUtils_PrintPatternBox (LONGINT pat, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER pX, INTEGER pY);
import void GraphicUtils_PrintString (CHAR *s, LONGINT s__len, INTEGER x, INTEGER y, INTEGER w, Fonts_Font fnt, INTEGER align, INTEGER *ret);
import void GraphicUtils_Set (Texts_Reader *r, LONGINT *r__typ, Texts_Text t, INTEGER *l);
import void GraphicUtils_TrackMenu (Display_Frame f, Texts_Text menu, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER n, INTEGER lsp, INTEGER dsc, INTEGER *sc, INTEGER *cmd);
import void *GraphicUtils__init(void);


#endif
