/* Ofront 1.4 -xtspkaG */

#ifndef TextAreaElems__h
#define TextAreaElems__h

#include "SYSTEM.h"
#include "Display.h"
#include "Elems.h"
#include "TextFrames.h"
#include "Texts.h"

typedef
	struct TextAreaElems_ElemDesc *TextAreaElems_Elem;

typedef
	struct TextAreaElems_ElemDesc { /* Elems_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[8];
		BOOLEAN locked;
		Texts_Text txt;
		BOOLEAN readOnly, scrBar;
	} TextAreaElems_ElemDesc;

typedef
	struct TextAreaElems_FrameDesc *TextAreaElems_Frame;

typedef
	struct TextAreaElems_FrameDesc { /* Display_FrameDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		TextAreaElems_Elem e;
	} TextAreaElems_FrameDesc;



import LONGINT *TextAreaElems_FrameDesc__typ;
import LONGINT *TextAreaElems_ElemDesc__typ;

import void TextAreaElems_Draw (TextAreaElems_Elem e, INTEGER x, INTEGER y, Display_Frame f);
import void TextAreaElems_FrameHandle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
import void TextAreaElems_Handle (Texts_Elem E, Texts_ElemMsg *msg, LONGINT *msg__typ);
import void TextAreaElems_Init (TextAreaElems_Elem e);
import void TextAreaElems_Insert (void);
import void TextAreaElems_InsertParc (TextAreaElems_Elem e, TextFrames_Frame f);
import void TextAreaElems_New (void);
import Display_Frame TextAreaElems_OpenFrame (TextAreaElems_Elem e, Display_Frame f, Display_Handler textHandler, Display_Handler frameHandler, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
import void TextAreaElems_TextHandle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
import void TextAreaElems_TextToString (Texts_Text t, LONGINT pos, CHAR *str, LONGINT str__len);
import void *TextAreaElems__init(void);


#endif
