/* Ofront 1.4 -xtspkaG */

#ifndef VersionElems__h
#define VersionElems__h

#include "SYSTEM.h"
#include "PopupElems.h"
#include "Texts.h"

typedef
	struct VersionElems_BegDesc *VersionElems_Beg;

typedef
	struct VersionElems_BegDesc { /* PopupElems_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
		CHAR name[32];
		Texts_Text menu;
		BOOLEAN small;
		INTEGER n, default_;
		char _prvt2[4];
		SET options;
		char _prvt3[32];
		CHAR vers[4][32];
		char _prvt4[16];
	} VersionElems_BegDesc;

typedef
	struct VersionElems_EndDesc *VersionElems_End;

typedef
	struct VersionElems_EndDesc { /* Texts_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
	} VersionElems_EndDesc;



import LONGINT *VersionElems_BegDesc__typ;
import LONGINT *VersionElems_EndDesc__typ;

import void VersionElems_AllocBeg (void);
import void VersionElems_AllocEnd (void);
import void VersionElems_Delete (void);
import void VersionElems_HandleBeg (Texts_Elem e, Texts_ElemMsg *m, LONGINT *m__typ);
import void VersionElems_HandleEnd (Texts_Elem e, Texts_ElemMsg *m, LONGINT *m__typ);
import void VersionElems_Insert (void);
import void VersionElems_Set (void);
import void VersionElems_SwitchAll (Texts_Text t, CHAR *version, LONGINT version__len);
import void *VersionElems__init(void);


#endif
