/* Ofront 1.4 -xtspkaG */

#ifndef Dates__h
#define Dates__h

#include "SYSTEM.h"
#include "Files.h"

typedef
	struct Dates_DateDesc *Dates_Date;

typedef
	struct Dates_DateDesc {
		INTEGER day, month, year, cal;
		LONGINT _prvt0;
	} Dates_DateDesc;

import void Dates_Date_AddDays (Dates_Date date, LONGINT days);
import void Dates_Date_AddMonths (Dates_Date date, INTEGER months, BOOLEAN trackUltimo);
import void Dates_Date_AddYears (Dates_Date date, INTEGER years, BOOLEAN trackUltimo);
import void Dates_Date_CopyTo (Dates_Date date, Dates_Date copy);
import LONGINT Dates_Date_Date (Dates_Date date);
import void Dates_Date_DayExt (Dates_Date date, CHAR *ext, LONGINT ext__len);
import void Dates_Date_DayName (Dates_Date date, BOOLEAN short_, CHAR *name, LONGINT name__len);
import INTEGER Dates_Date_DayOfWeek (Dates_Date date);
import INTEGER Dates_Date_DaysOfMonth (Dates_Date date);
import LONGINT Dates_Date_DaysUpTo (Dates_Date date, Dates_Date other);
import void Dates_Date_Format (Dates_Date date, CHAR *f, LONGINT f__len, CHAR *d, LONGINT d__len);
import void Dates_Date_Init (Dates_Date date);
import BOOLEAN Dates_Date_IsLeapYear (Dates_Date date);
import BOOLEAN Dates_Date_LaterThan (Dates_Date date, Dates_Date other);
import void Dates_Date_Load (Dates_Date date, Files_Rider *r, LONGINT *r__typ);
import void Dates_Date_MonthName (Dates_Date date, BOOLEAN short_, CHAR *name, LONGINT name__len);
import LONGINT Dates_Date_Ref (Dates_Date date);
import void Dates_Date_Set (Dates_Date date, INTEGER day, INTEGER month, INTEGER year);
import void Dates_Date_SetCal (Dates_Date date, INTEGER cal);
import void Dates_Date_SetToDate (Dates_Date date, LONGINT d);
import void Dates_Date_SetToRef (Dates_Date date, LONGINT ref);
import void Dates_Date_SetToday (Dates_Date date);
import void Dates_Date_Store (Dates_Date date, Files_Rider *r, LONGINT *r__typ);
import INTEGER Dates_Date_WeekOfYear (Dates_Date date);
import void Dates_Date_YearExt (Dates_Date date, CHAR *ext, LONGINT ext__len);
#define __Dates_Date_AddDays(date, days) __SEND(__TYPEOF(date), 0, void(*)(Dates_Date, LONGINT), (date, days))
#define __Dates_Date_AddMonths(date, months, trackUltimo) __SEND(__TYPEOF(date), 1, void(*)(Dates_Date, INTEGER, BOOLEAN), (date, months, trackUltimo))
#define __Dates_Date_AddYears(date, years, trackUltimo) __SEND(__TYPEOF(date), 2, void(*)(Dates_Date, INTEGER, BOOLEAN), (date, years, trackUltimo))
#define __Dates_Date_CopyTo(date, copy) __SEND(__TYPEOF(date), 5, void(*)(Dates_Date, Dates_Date), (date, copy))
#define __Dates_Date_Date(date) __SEND(__TYPEOF(date), 6, LONGINT(*)(Dates_Date), (date))
#define __Dates_Date_DayExt(date, ext, ext__len) __SEND(__TYPEOF(date), 7, void(*)(Dates_Date, CHAR*, LONGINT ), (date, ext, ext__len))
#define __Dates_Date_DayName(date, short, name, name__len) __SEND(__TYPEOF(date), 8, void(*)(Dates_Date, BOOLEAN, CHAR*, LONGINT ), (date, short, name, name__len))
#define __Dates_Date_DayOfWeek(date) __SEND(__TYPEOF(date), 9, INTEGER(*)(Dates_Date), (date))
#define __Dates_Date_DaysOfMonth(date) __SEND(__TYPEOF(date), 10, INTEGER(*)(Dates_Date), (date))
#define __Dates_Date_DaysUpTo(date, other) __SEND(__TYPEOF(date), 11, LONGINT(*)(Dates_Date, Dates_Date), (date, other))
#define __Dates_Date_Format(date, f, f__len, d, d__len) __SEND(__TYPEOF(date), 12, void(*)(Dates_Date, CHAR*, LONGINT , CHAR*, LONGINT ), (date, f, f__len, d, d__len))
#define __Dates_Date_Init(date) __SEND(__TYPEOF(date), 14, void(*)(Dates_Date), (date))
#define __Dates_Date_IsLeapYear(date) __SEND(__TYPEOF(date), 15, BOOLEAN(*)(Dates_Date), (date))
#define __Dates_Date_LaterThan(date, other) __SEND(__TYPEOF(date), 16, BOOLEAN(*)(Dates_Date, Dates_Date), (date, other))
#define __Dates_Date_Load(date, r, r__typ) __SEND(__TYPEOF(date), 17, void(*)(Dates_Date, Files_Rider*, LONGINT *), (date, r, r__typ))
#define __Dates_Date_MonthName(date, short, name, name__len) __SEND(__TYPEOF(date), 18, void(*)(Dates_Date, BOOLEAN, CHAR*, LONGINT ), (date, short, name, name__len))
#define __Dates_Date_Ref(date) __SEND(__TYPEOF(date), 19, LONGINT(*)(Dates_Date), (date))
#define __Dates_Date_Set(date, day, month, year) __SEND(__TYPEOF(date), 20, void(*)(Dates_Date, INTEGER, INTEGER, INTEGER), (date, day, month, year))
#define __Dates_Date_SetCal(date, cal) __SEND(__TYPEOF(date), 21, void(*)(Dates_Date, INTEGER), (date, cal))
#define __Dates_Date_SetToDate(date, d) __SEND(__TYPEOF(date), 22, void(*)(Dates_Date, LONGINT), (date, d))
#define __Dates_Date_SetToRef(date, ref) __SEND(__TYPEOF(date), 23, void(*)(Dates_Date, LONGINT), (date, ref))
#define __Dates_Date_SetToday(date) __SEND(__TYPEOF(date), 24, void(*)(Dates_Date), (date))
#define __Dates_Date_Store(date, r, r__typ) __SEND(__TYPEOF(date), 25, void(*)(Dates_Date, Files_Rider*, LONGINT *), (date, r, r__typ))
#define __Dates_Date_WeekOfYear(date) __SEND(__TYPEOF(date), 26, INTEGER(*)(Dates_Date), (date))
#define __Dates_Date_YearExt(date, ext, ext__len) __SEND(__TYPEOF(date), 27, void(*)(Dates_Date, CHAR*, LONGINT ), (date, ext, ext__len))



import LONGINT *Dates_DateDesc__typ;

import void *Dates__init(void);


#endif
