/* Ofront 1.4 -xtspkaG */

#ifndef DialogCircles__h
#define DialogCircles__h

#include "SYSTEM.h"
#include "Dialogs.h"
#include "Display.h"

typedef
	struct DialogCircles_ItemDesc *DialogCircles_Item;

typedef
	struct DialogCircles_ItemDesc { /* Dialogs_ObjectDesc */
		LONGINT _prvt0;
		char _prvt1[16];
		CHAR name[16];
		CHAR cmd[32];
		CHAR par[32];
		BOOLEAN selected, overlapping;
		Dialogs_Panel panel;
		char _prvt2[1];
	} DialogCircles_ItemDesc;

import void DialogCircles_Item_Copy (DialogCircles_Item c, Dialogs_Object *dup);
import void DialogCircles_Item_Draw (DialogCircles_Item c, INTEGER x, INTEGER y, Display_Frame f);
import void DialogCircles_Item_Handle (DialogCircles_Item c, Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ);
import void DialogCircles_Item_Print (DialogCircles_Item l, INTEGER x, INTEGER y);



import LONGINT *DialogCircles_ItemDesc__typ;

import void DialogCircles_Insert (void);
import void *DialogCircles__init(void);


#endif
