/* Ofront 1.4 -xtspkaG */

#ifndef DialogGroupBoxes__h
#define DialogGroupBoxes__h

#include "SYSTEM.h"
#include "Dialogs.h"
#include "Display.h"
#include "Files.h"
#include "Fonts.h"

typedef
	struct DialogGroupBoxes_ItemDesc *DialogGroupBoxes_Item;

typedef
	struct DialogGroupBoxes_ItemDesc { /* Dialogs_ObjectDesc */
		LONGINT _prvt0;
		char _prvt1[16];
		CHAR name[16];
		CHAR cmd[32];
		CHAR par[32];
		BOOLEAN selected, overlapping;
		Dialogs_Panel panel;
		char _prvt2[4];
		Fonts_Font fnt;
		CHAR s[64];
	} DialogGroupBoxes_ItemDesc;

import void DialogGroupBoxes_Item_Copy (DialogGroupBoxes_Item g, Dialogs_Object *dup);
import void DialogGroupBoxes_Item_Draw (DialogGroupBoxes_Item g, INTEGER x, INTEGER y, Display_Frame f);
import void DialogGroupBoxes_Item_Edit (DialogGroupBoxes_Item g);
import void DialogGroupBoxes_Item_GetObjects (DialogGroupBoxes_Item g, Dialogs_Object *obArray, LONGINT obArray__len, INTEGER *nofelems);
import void DialogGroupBoxes_Item_Handle (DialogGroupBoxes_Item g, Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ);
import void DialogGroupBoxes_Item_Load (DialogGroupBoxes_Item g, Files_Rider *r, LONGINT *r__typ);
import void DialogGroupBoxes_Item_Print (DialogGroupBoxes_Item g, INTEGER x, INTEGER y);
import void DialogGroupBoxes_Item_SetFont (DialogGroupBoxes_Item g, Fonts_Font fnt);
import void DialogGroupBoxes_Item_SetString (DialogGroupBoxes_Item g, CHAR *s, LONGINT s__len);
import void DialogGroupBoxes_Item_Store (DialogGroupBoxes_Item g, Files_Rider *r, LONGINT *r__typ);
import void DialogGroupBoxes_Item_Update (DialogGroupBoxes_Item g, Dialogs_Panel p);
#define __DialogGroupBoxes_Item_GetObjects(g, obArray, obArray__len, nofelems) __SEND(__TYPEOF(g), 24, void(*)(DialogGroupBoxes_Item, Dialogs_Object*, LONGINT , INTEGER*), (g, obArray, obArray__len, nofelems))
#define __DialogGroupBoxes_Item_SetFont(g, fnt) __SEND(__TYPEOF(g), 25, void(*)(DialogGroupBoxes_Item, Fonts_Font), (g, fnt))
#define __DialogGroupBoxes_Item_SetString(g, s, s__len) __SEND(__TYPEOF(g), 26, void(*)(DialogGroupBoxes_Item, CHAR*, LONGINT ), (g, s, s__len))



import LONGINT *DialogGroupBoxes_ItemDesc__typ;

import void DialogGroupBoxes_GetString (void);
import void DialogGroupBoxes_Insert (void);
import void DialogGroupBoxes_SetString (void);
import void *DialogGroupBoxes__init(void);


#endif
