/* Ofront 1.4 -xtspkaG */

#ifndef DialogStaticTexts__h
#define DialogStaticTexts__h

#include "SYSTEM.h"
#include "Dialogs.h"
#include "Display.h"
#include "Files.h"
#include "Fonts.h"

typedef
	struct DialogStaticTexts_ItemDesc *DialogStaticTexts_Item;

typedef
	struct DialogStaticTexts_ItemDesc { /* Dialogs_ObjectDesc */
		LONGINT _prvt0;
		char _prvt1[16];
		CHAR name[16];
		CHAR cmd[32];
		CHAR par[32];
		BOOLEAN selected, overlapping;
		Dialogs_Panel panel;
		char _prvt2[4];
		Fonts_Font fnt;
		CHAR s[64];
		INTEGER a;
	} DialogStaticTexts_ItemDesc;

import void DialogStaticTexts_Item_Copy (DialogStaticTexts_Item t, Dialogs_Object *dup);
import void DialogStaticTexts_Item_Draw (DialogStaticTexts_Item t, INTEGER x, INTEGER y, Display_Frame f);
import void DialogStaticTexts_Item_Edit (DialogStaticTexts_Item t);
import void DialogStaticTexts_Item_Handle (DialogStaticTexts_Item t, Display_Frame f, Display_FrameMsg *m, LONGINT *m__typ);
import void DialogStaticTexts_Item_Load (DialogStaticTexts_Item t, Files_Rider *r, LONGINT *r__typ);
import void DialogStaticTexts_Item_Print (DialogStaticTexts_Item t, INTEGER x, INTEGER y);
import void DialogStaticTexts_Item_SetAlign (DialogStaticTexts_Item t, INTEGER a);
import void DialogStaticTexts_Item_SetFont (DialogStaticTexts_Item t, Fonts_Font fnt);
import void DialogStaticTexts_Item_SetString (DialogStaticTexts_Item t, CHAR *s, LONGINT s__len);
import void DialogStaticTexts_Item_Store (DialogStaticTexts_Item t, Files_Rider *r, LONGINT *r__typ);
import void DialogStaticTexts_Item_Update (DialogStaticTexts_Item t, Dialogs_Panel p);
#define __DialogStaticTexts_Item_SetAlign(t, a) __SEND(__TYPEOF(t), 24, void(*)(DialogStaticTexts_Item, INTEGER), (t, a))
#define __DialogStaticTexts_Item_SetFont(t, fnt) __SEND(__TYPEOF(t), 25, void(*)(DialogStaticTexts_Item, Fonts_Font), (t, fnt))
#define __DialogStaticTexts_Item_SetString(t, s, s__len) __SEND(__TYPEOF(t), 26, void(*)(DialogStaticTexts_Item, CHAR*, LONGINT ), (t, s, s__len))



import LONGINT *DialogStaticTexts_ItemDesc__typ;

import void DialogStaticTexts_GetString (void);
import void DialogStaticTexts_Insert (void);
import void DialogStaticTexts_SetString (void);
import void *DialogStaticTexts__init(void);


#endif
