/* Ofront 1.4 -xtspkaG */

#ifndef Directories__h
#define Directories__h

#include "SYSTEM.h"

typedef
	struct Directories_DirectoryDesc *Directories_Directory;

typedef
	struct Directories_DirectoryDesc {
		CHAR path[128];
	} Directories_DirectoryDesc;

typedef
	void (*Directories_FileProc)(Directories_Directory, CHAR*, LONGINT , BOOLEAN, BOOLEAN*);

typedef
	void (*Directories_Notifier)(INTEGER, CHAR*, LONGINT , CHAR*, LONGINT );

typedef
	void (*Directories_PathProc)(CHAR*, LONGINT , BOOLEAN*);


import INTEGER Directories_res;
import Directories_Notifier Directories_notify;

import LONGINT *Directories_DirectoryDesc__typ;

import void Directories_Change (CHAR *path, LONGINT path__len);
import Directories_Directory Directories_Current (void);
import void Directories_Enumerate (Directories_Directory D, Directories_FileProc H);
import void Directories_LocalToURL (CHAR *name, LONGINT name__len);
import Directories_Directory Directories_Startup (void);
import Directories_Directory Directories_This (CHAR *path, LONGINT path__len);
import void Directories_URLToLocal (CHAR *name, LONGINT name__len);
import void *Directories__init(void);


#endif
