/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "Display.h"
#include "Display1.h"
#include "Fonts.h"
#include "Printer.h"
#include "TextPrinter.h"

typedef
	struct KeplerPorts_BalloonPortDesc *KeplerPorts_BalloonPort;

typedef
	struct KeplerPorts_PortDesc *KeplerPorts_Port;

typedef
	struct KeplerPorts_PortDesc { /* Display_FrameDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		INTEGER x0, y0, scale;
		KeplerPorts_Port ext;
	} KeplerPorts_PortDesc;

export INTEGER KeplerPorts_Port_CX (KeplerPorts_Port P, INTEGER x);
export INTEGER KeplerPorts_Port_CY (KeplerPorts_Port P, INTEGER y);
export INTEGER KeplerPorts_Port_Cx (KeplerPorts_Port P, INTEGER X);
export INTEGER KeplerPorts_Port_Cy (KeplerPorts_Port P, INTEGER Y);
export void KeplerPorts_Port_DrawCircle (KeplerPorts_Port P, INTEGER x, INTEGER y, INTEGER r, INTEGER col, INTEGER mode);
export void KeplerPorts_Port_DrawEllipse (KeplerPorts_Port P, INTEGER x, INTEGER y, INTEGER a, INTEGER b, INTEGER col, INTEGER mode);
export void KeplerPorts_Port_DrawLine (KeplerPorts_Port P, INTEGER x1, INTEGER y1, INTEGER x2, INTEGER y2, INTEGER col, INTEGER mode);
export void KeplerPorts_Port_DrawRect (KeplerPorts_Port P, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER col, INTEGER mode);
export void KeplerPorts_Port_DrawString (KeplerPorts_Port P, INTEGER x, INTEGER y, CHAR *s, LONGINT s__len, Fonts_Font font, INTEGER col, INTEGER mode);
export void KeplerPorts_Port_FillCircle (KeplerPorts_Port P, INTEGER x, INTEGER y, INTEGER r, INTEGER col, INTEGER pat, INTEGER mode);
export void KeplerPorts_Port_FillQuad (KeplerPorts_Port P, INTEGER x1, INTEGER y1, INTEGER x2, INTEGER y2, INTEGER x3, INTEGER y3, INTEGER x4, INTEGER y4, INTEGER col, INTEGER pat, INTEGER mode);
export void KeplerPorts_Port_FillRect (KeplerPorts_Port P, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER col, INTEGER pat, INTEGER mode);
#define __KeplerPorts_Port_CX(P, x) __SEND(__TYPEOF(P), 0, INTEGER(*)(KeplerPorts_Port, INTEGER), (P, x))
#define __KeplerPorts_Port_CY(P, y) __SEND(__TYPEOF(P), 1, INTEGER(*)(KeplerPorts_Port, INTEGER), (P, y))
#define __KeplerPorts_Port_Cx(P, X) __SEND(__TYPEOF(P), 2, INTEGER(*)(KeplerPorts_Port, INTEGER), (P, X))
#define __KeplerPorts_Port_Cy(P, Y) __SEND(__TYPEOF(P), 3, INTEGER(*)(KeplerPorts_Port, INTEGER), (P, Y))
#define __KeplerPorts_Port_DrawCircle(P, x, y, r, col, mode) __SEND(__TYPEOF(P), 4, void(*)(KeplerPorts_Port, INTEGER, INTEGER, INTEGER, INTEGER, INTEGER), (P, x, y, r, col, mode))
#define __KeplerPorts_Port_DrawEllipse(P, x, y, a, b, col, mode) __SEND(__TYPEOF(P), 5, void(*)(KeplerPorts_Port, INTEGER, INTEGER, INTEGER, INTEGER, INTEGER, INTEGER), (P, x, y, a, b, col, mode))
#define __KeplerPorts_Port_DrawLine(P, x1, y1, x2, y2, col, mode) __SEND(__TYPEOF(P), 6, void(*)(KeplerPorts_Port, INTEGER, INTEGER, INTEGER, INTEGER, INTEGER, INTEGER), (P, x1, y1, x2, y2, col, mode))
#define __KeplerPorts_Port_DrawRect(P, x, y, w, h, col, mode) __SEND(__TYPEOF(P), 7, void(*)(KeplerPorts_Port, INTEGER, INTEGER, INTEGER, INTEGER, INTEGER, INTEGER), (P, x, y, w, h, col, mode))
#define __KeplerPorts_Port_DrawString(P, x, y, s, s__len, font, col, mode) __SEND(__TYPEOF(P), 8, void(*)(KeplerPorts_Port, INTEGER, INTEGER, CHAR*, LONGINT , Fonts_Font, INTEGER, INTEGER), (P, x, y, s, s__len, font, col, mode))
#define __KeplerPorts_Port_FillCircle(P, x, y, r, col, pat, mode) __SEND(__TYPEOF(P), 9, void(*)(KeplerPorts_Port, INTEGER, INTEGER, INTEGER, INTEGER, INTEGER, INTEGER), (P, x, y, r, col, pat, mode))
#define __KeplerPorts_Port_FillQuad(P, x1, y1, x2, y2, x3, y3, x4, y4, col, pat, mode) __SEND(__TYPEOF(P), 10, void(*)(KeplerPorts_Port, INTEGER, INTEGER, INTEGER, INTEGER, INTEGER, INTEGER, INTEGER, INTEGER, INTEGER, INTEGER, INTEGER), (P, x1, y1, x2, y2, x3, y3, x4, y4, col, pat, mode))
#define __KeplerPorts_Port_FillRect(P, x, y, w, h, col, pat, mode) __SEND(__TYPEOF(P), 11, void(*)(KeplerPorts_Port, INTEGER, INTEGER, INTEGER, INTEGER, INTEGER, INTEGER, INTEGER), (P, x, y, w, h, col, pat, mode))

typedef
	struct KeplerPorts_BalloonPortDesc { /* KeplerPorts_PortDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		INTEGER x0, y0, scale;
		KeplerPorts_Port ext;
	} KeplerPorts_BalloonPortDesc;

export void KeplerPorts_BalloonPort_DrawCircle (KeplerPorts_BalloonPort P, INTEGER x, INTEGER y, INTEGER r, INTEGER col, INTEGER mode);
export void KeplerPorts_BalloonPort_DrawEllipse (KeplerPorts_BalloonPort P, INTEGER x, INTEGER y, INTEGER a, INTEGER b, INTEGER col, INTEGER mode);
export void KeplerPorts_BalloonPort_DrawLine (KeplerPorts_BalloonPort P, INTEGER x1, INTEGER y1, INTEGER x2, INTEGER y2, INTEGER col, INTEGER mode);
export void KeplerPorts_BalloonPort_DrawRect (KeplerPorts_BalloonPort P, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER col, INTEGER mode);
export void KeplerPorts_BalloonPort_DrawString (KeplerPorts_BalloonPort P, INTEGER x, INTEGER y, CHAR *s, LONGINT s__len, Fonts_Font font, INTEGER col, INTEGER mode);
export void KeplerPorts_BalloonPort_FillCircle (KeplerPorts_BalloonPort P, INTEGER x, INTEGER y, INTEGER r, INTEGER col, INTEGER pat, INTEGER mode);
export void KeplerPorts_BalloonPort_FillQuad (KeplerPorts_BalloonPort P, INTEGER x1, INTEGER y1, INTEGER x2, INTEGER y2, INTEGER x3, INTEGER y3, INTEGER x4, INTEGER y4, INTEGER col, INTEGER pat, INTEGER mode);
export void KeplerPorts_BalloonPort_FillRect (KeplerPorts_BalloonPort P, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER col, INTEGER pat, INTEGER mode);

typedef
	struct KeplerPorts_DisplayPortDesc *KeplerPorts_DisplayPort;

typedef
	struct KeplerPorts_DisplayPortDesc { /* KeplerPorts_PortDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		INTEGER x0, y0, scale;
		KeplerPorts_Port ext;
	} KeplerPorts_DisplayPortDesc;

export void KeplerPorts_DisplayPort_DrawCircle (KeplerPorts_DisplayPort P, INTEGER x, INTEGER y, INTEGER r, INTEGER col, INTEGER mode);
export void KeplerPorts_DisplayPort_DrawEllipse (KeplerPorts_DisplayPort P, INTEGER x, INTEGER y, INTEGER a, INTEGER b, INTEGER col, INTEGER mode);
export void KeplerPorts_DisplayPort_DrawLine (KeplerPorts_DisplayPort P, INTEGER x1, INTEGER y1, INTEGER x2, INTEGER y2, INTEGER col, INTEGER mode);
export void KeplerPorts_DisplayPort_DrawString (KeplerPorts_DisplayPort P, INTEGER x, INTEGER y, CHAR *s, LONGINT s__len, Fonts_Font font, INTEGER col, INTEGER mode);
export void KeplerPorts_DisplayPort_FillRect (KeplerPorts_DisplayPort P, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER col, INTEGER pat, INTEGER mode);

typedef
	struct KeplerPorts_PrinterPortDesc *KeplerPorts_PrinterPort;

typedef
	struct KeplerPorts_PrinterPortDesc { /* KeplerPorts_PortDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		INTEGER x0, y0, scale;
		KeplerPorts_Port ext;
	} KeplerPorts_PrinterPortDesc;

export void KeplerPorts_PrinterPort_DrawCircle (KeplerPorts_PrinterPort P, INTEGER x, INTEGER y, INTEGER r, INTEGER col, INTEGER mode);
export void KeplerPorts_PrinterPort_DrawEllipse (KeplerPorts_PrinterPort P, INTEGER x, INTEGER y, INTEGER a, INTEGER b, INTEGER col, INTEGER mode);
export void KeplerPorts_PrinterPort_DrawLine (KeplerPorts_PrinterPort P, INTEGER x1, INTEGER y1, INTEGER x2, INTEGER y2, INTEGER col, INTEGER mode);
export void KeplerPorts_PrinterPort_DrawString (KeplerPorts_PrinterPort P, INTEGER x, INTEGER y, CHAR *s, LONGINT s__len, Fonts_Font font, INTEGER col, INTEGER mode);
export void KeplerPorts_PrinterPort_FillRect (KeplerPorts_PrinterPort P, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER col, INTEGER pat, INTEGER mode);



export LONGINT *KeplerPorts_PortDesc__typ;
export LONGINT *KeplerPorts_DisplayPortDesc__typ;
export LONGINT *KeplerPorts_PrinterPortDesc__typ;
export LONGINT *KeplerPorts_BalloonPortDesc__typ;
static LONGINT *LineParms__14__typ;

static void KeplerPorts_BlowUp (KeplerPorts_Port P, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
static void KeplerPorts_HairEllipse (KeplerPorts_Port P, INTEGER X, INTEGER Y, INTEGER A, INTEGER B, INTEGER col, INTEGER mode);
export void KeplerPorts_InitBalloon (KeplerPorts_BalloonPort P);
static BOOLEAN KeplerPorts_Intersect (KeplerPorts_Port F, INTEGER *X, INTEGER *Y, INTEGER *W, INTEGER *H);
static void KeplerPorts_Line2 (KeplerPorts_Port P, INTEGER col, INTEGER pat, INTEGER mode, INTEGER x1, INTEGER x2, INTEGER y1, INTEGER y2);
static void KeplerPorts_MinMax (INTEGER x, INTEGER y, INTEGER *min, INTEGER *max);
export INTEGER KeplerPorts_StringWidth (CHAR *s, LONGINT s__len, Fonts_Font f);


void KeplerPorts_Port_FillRect (KeplerPorts_Port P, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER col, INTEGER pat, INTEGER mode)
{
}

void KeplerPorts_Port_DrawString (KeplerPorts_Port P, INTEGER x, INTEGER y, CHAR *s, LONGINT s__len, Fonts_Font font, INTEGER col, INTEGER mode)
{
	__DUP(s, s__len, CHAR);
	__DEL(s);
}

INTEGER KeplerPorts_Port_CX (KeplerPorts_Port P, INTEGER x)
{
	return P->X + __DIV(P->x0 + x, P->scale);
}

INTEGER KeplerPorts_Port_CY (KeplerPorts_Port P, INTEGER y)
{
	return (P->Y + P->H) + __DIV(P->y0 + y, P->scale);
}

INTEGER KeplerPorts_Port_Cx (KeplerPorts_Port P, INTEGER X)
{
	return (X - P->X) * P->scale - P->x0;
}

INTEGER KeplerPorts_Port_Cy (KeplerPorts_Port P, INTEGER Y)
{
	return ((Y - P->Y) - P->H) * P->scale - P->y0;
}

void KeplerPorts_Port_DrawLine (KeplerPorts_Port P, INTEGER x1, INTEGER y1, INTEGER x2, INTEGER y2, INTEGER col, INTEGER mode)
{
	INTEGER x = 0, y = 0, dx = 0, dy = 0, d = 0, inc = 0, Xmin = 0, Xmax = 0, Ymin = 0, Ymax = 0;
	x1 = __KeplerPorts_Port_CX(P, x1);
	y1 = __KeplerPorts_Port_CY(P, y1);
	x2 = __KeplerPorts_Port_CX(P, x2);
	y2 = __KeplerPorts_Port_CY(P, y2);
	if (x1 < x2) {
		Xmin = x1;
		Xmax = x2;
	} else {
		Xmin = x2;
		Xmax = x1;
	}
	if (y1 < y2) {
		Ymin = y1;
		Ymax = y2;
	} else {
		Ymin = y2;
		Ymax = y1;
	}
	if (y2 - y1 < x1 - x2) {
		x = x1;
		x1 = x2;
		x2 = x;
		y = y1;
		y1 = y2;
		y2 = y;
	}
	dx = __ASHL(x2 - x1, 1);
	dy = __ASHL(y2 - y1, 1);
	x = x1;
	y = y1;
	inc = 1;
	if (dy > dx) {
		d = __ASHR(dy, 1);
		if (dx < 0) {
			inc = -1;
			dx = -dx;
		}
		while (y <= y2) {
			__KeplerPorts_Port_FillRect(P, __KeplerPorts_Port_Cx(P, x), __KeplerPorts_Port_Cy(P, y), P->scale, P->scale, col, 5, mode);
			y += 1;
			d -= dx;
			if (d < 0) {
				d += dy;
				x += inc;
			}
		}
	} else {
		d = __ASHR(dx, 1);
		if (dy < 0) {
			inc = -1;
			dy = -dy;
		}
		while (x <= x2) {
			__KeplerPorts_Port_FillRect(P, __KeplerPorts_Port_Cx(P, x), __KeplerPorts_Port_Cy(P, y), P->scale, P->scale, col, 5, mode);
			x += 1;
			d -= dy;
			if (d < 0) {
				d += dx;
				y += inc;
			}
		}
	}
}

void KeplerPorts_Port_DrawRect (KeplerPorts_Port P, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER col, INTEGER mode)
{
	if (P->scale == 1) {
		x -= 1;
		y -= 1;
		__KeplerPorts_Port_FillRect(P, x, y, w + 3, 3, col, 5, mode);
		__KeplerPorts_Port_FillRect(P, x + w, y, 3, h + 3, col, 5, mode);
		__KeplerPorts_Port_FillRect(P, x, y + h, w + 3, 3, col, 5, mode);
		__KeplerPorts_Port_FillRect(P, x, y, 3, h + 3, col, 5, mode);
	} else {
		__KeplerPorts_Port_FillRect(P, x, y, w, P->scale, col, 5, mode);
		__KeplerPorts_Port_FillRect(P, (x + w) - P->scale, y, P->scale, h, col, 5, mode);
		__KeplerPorts_Port_FillRect(P, x, (y + h) - P->scale, w, P->scale, col, 5, mode);
		__KeplerPorts_Port_FillRect(P, x, y, P->scale, h, col, 5, mode);
	}
}

static struct HairEllipse__41 {
	KeplerPorts_Port *P;
	struct HairEllipse__41 *lnk;
} *HairEllipse__41_s;

static void Dot4__42 (INTEGER x1, INTEGER x2, INTEGER y1, INTEGER y2, INTEGER col, INTEGER mode);

static void Dot4__42 (INTEGER x1, INTEGER x2, INTEGER y1, INTEGER y2, INTEGER col, INTEGER mode)
{
	__KeplerPorts_Port_FillRect(*HairEllipse__41_s->P, x1, y1, (*HairEllipse__41_s->P)->scale, (*HairEllipse__41_s->P)->scale, col, 5, mode);
	__KeplerPorts_Port_FillRect(*HairEllipse__41_s->P, x1, y2, (*HairEllipse__41_s->P)->scale, (*HairEllipse__41_s->P)->scale, col, 5, mode);
	__KeplerPorts_Port_FillRect(*HairEllipse__41_s->P, x2, y1, (*HairEllipse__41_s->P)->scale, (*HairEllipse__41_s->P)->scale, col, 5, mode);
	__KeplerPorts_Port_FillRect(*HairEllipse__41_s->P, x2, y2, (*HairEllipse__41_s->P)->scale, (*HairEllipse__41_s->P)->scale, col, 5, mode);
}

static void KeplerPorts_HairEllipse (KeplerPorts_Port P, INTEGER X, INTEGER Y, INTEGER A, INTEGER B, INTEGER col, INTEGER mode)
{
	INTEGER x = 0, y = 0;
	LONGINT d = 0, dx = 0, dy = 0, x2 = 0, y2 = 0, a = 0, a2 = 0, a8 = 0, b = 0, b2 = 0, b8 = 0;
	struct HairEllipse__41 _s;
	_s.P = &P;
	_s.lnk = HairEllipse__41_s;
	HairEllipse__41_s = &_s;
	if (A == B) {
		A -= 1;
		x = A;
		y = 0;
		dx = __ASHL(x - 1, 3);
		dy = __ASHL(y, 3) + 4;
		d = 1 - __ASHL(A, 2);
		while (x > y) {
			Dot4__42(__KeplerPorts_Port_Cx(P, (X - x) - 1), __KeplerPorts_Port_Cx(P, X + x), __KeplerPorts_Port_Cy(P, (Y - y) - 1), __KeplerPorts_Port_Cy(P, Y + y), col, mode);
			Dot4__42(__KeplerPorts_Port_Cx(P, (X - y) - 1), __KeplerPorts_Port_Cx(P, X + y), __KeplerPorts_Port_Cy(P, (Y - x) - 1), __KeplerPorts_Port_Cy(P, Y + x), col, mode);
			d += dy;
			dy += 8;
			y += 1;
			if (d >= 0) {
				d -= dx;
				dx -= 8;
				x -= 1;
			}
		}
		if (x == y) {
			Dot4__42(__KeplerPorts_Port_Cx(P, (X - x) - 1), __KeplerPorts_Port_Cx(P, X + x), __KeplerPorts_Port_Cy(P, (Y - y) - 1), __KeplerPorts_Port_Cy(P, Y + y), col, mode);
		}
	} else if (A > 0 && B > 0) {
		A -= 1;
		B -= 1;
		a = A;
		a2 = a * a;
		a8 = __ASHL(a2, 3);
		b = B;
		b2 = b * b;
		b8 = __ASHL(b2, 3);
		x = A;
		y = 0;
		x2 = a * b2;
		y2 = 0;
		dx = b8 * (a - 1);
		dy = __ASHL(a2, 2);
		d = b2 * (1 - __ASHL(a, 2));
		while (y2 < x2) {
			Dot4__42(__KeplerPorts_Port_Cx(P, (X - x) - 1), __KeplerPorts_Port_Cx(P, X + x), __KeplerPorts_Port_Cy(P, (Y - y) - 1), __KeplerPorts_Port_Cy(P, Y + y), col, mode);
			d += dy;
			dy += a8;
			y += 1;
			y2 += a2;
			if (d >= 0) {
				d -= dx;
				dx -= b8;
				x -= 1;
				x2 -= b2;
			}
		}
		d += (__ASHL(x2 + y2, 2) - b2) + a2;
		while (x >= 0) {
			Dot4__42(__KeplerPorts_Port_Cx(P, (X - x) - 1), __KeplerPorts_Port_Cx(P, X + x), __KeplerPorts_Port_Cy(P, (Y - y) - 1), __KeplerPorts_Port_Cy(P, Y + y), col, mode);
			d -= dx;
			dx -= b8;
			x -= 1;
			if (d < 0) {
				d += dy;
				dy += a8;
				y += 1;
			}
		}
	}
	HairEllipse__41_s = _s.lnk;
}

void KeplerPorts_Port_DrawEllipse (KeplerPorts_Port P, INTEGER x, INTEGER y, INTEGER a, INTEGER b, INTEGER col, INTEGER mode)
{
	KeplerPorts_HairEllipse(P, __KeplerPorts_Port_CX(P, x), __KeplerPorts_Port_CY(P, y), __DIV(a, P->scale), __DIV(b, P->scale), col, mode);
}

void KeplerPorts_Port_DrawCircle (KeplerPorts_Port P, INTEGER x, INTEGER y, INTEGER r, INTEGER col, INTEGER mode)
{
	KeplerPorts_HairEllipse(P, __KeplerPorts_Port_CX(P, x), __KeplerPorts_Port_CY(P, y), __DIV(r, P->scale), __DIV(r, P->scale), col, mode);
}

static void KeplerPorts_Line2 (KeplerPorts_Port P, INTEGER col, INTEGER pat, INTEGER mode, INTEGER x1, INTEGER x2, INTEGER y1, INTEGER y2)
{
	x1 = __KeplerPorts_Port_Cx(P, x1);
	x2 = __KeplerPorts_Port_Cx(P, x2);
	y1 = __KeplerPorts_Port_Cy(P, y1);
	y2 = __KeplerPorts_Port_Cy(P, y2);
	__KeplerPorts_Port_FillRect(P, x1, y1, x2 - x1, P->scale, col, pat, mode);
	__KeplerPorts_Port_FillRect(P, x1, y2, x2 - x1, P->scale, col, pat, mode);
}

void KeplerPorts_Port_FillCircle (KeplerPorts_Port P, INTEGER x, INTEGER y, INTEGER r, INTEGER col, INTEGER pat, INTEGER mode)
{
	INTEGER x1 = 0, y1 = 0, d = 0, dx = 0, dy = 0;
	x = __KeplerPorts_Port_CX(P, x);
	y = __KeplerPorts_Port_CY(P, y);
	r = __DIV(r, P->scale);
	if (((P->X < x + r && x - r < P->X + P->W) && P->Y < y + r) && y - r < P->Y + P->H) {
		x1 = r - 1;
		y1 = 0;
		dx = __ASHL(x1 - 1, 3);
		dy = __ASHL(y1, 3) + 4;
		d = 3 - __ASHL(r, 2);
		while (x1 > y1) {
			KeplerPorts_Line2(P, col, pat, mode, (x - x1) - 1, x + x1, (y - y1) - 1, y + y1);
			if (d + dy >= 0) {
				KeplerPorts_Line2(P, col, pat, mode, (x - y1) - 1, x + y1, (y - x1) - 1, y + x1);
			}
			d += dy;
			dy += 8;
			y1 += 1;
			if (d >= 0) {
				d -= dx;
				dx -= 8;
				x1 -= 1;
			}
		}
		if (x1 == y1) {
			KeplerPorts_Line2(P, col, pat, mode, (x - x1) - 1, x + x1, (y - y1) - 1, y + y1);
		}
	}
}

typedef
	struct LineParms__14 {
		INTEGER x, y, d, dx, dy, inx, iny, drawX, drawY;
	} LineParms__14;

static struct FillQuad__11 {
	struct FillQuad__11 *lnk;
} *FillQuad__11_s;

static void InitLineParms__12 (INTEGER x1, INTEGER y1, INTEGER x2, INTEGER y2, LineParms__14 *p, LONGINT *p__typ);
static void LineStep__15 (LineParms__14 *p, LONGINT *p__typ);
static LONGINT Max4__17 (LONGINT a, LONGINT b, LONGINT c, LONGINT d);
static LONGINT Min4__19 (LONGINT a, LONGINT b, LONGINT c, LONGINT d);

static void InitLineParms__12 (INTEGER x1, INTEGER y1, INTEGER x2, INTEGER y2, LineParms__14 *p, LONGINT *p__typ)
{
	(*p).x = x1;
	(*p).dx = x2 - x1;
	if ((*p).dx > 0) {
		(*p).inx = 1;
	} else if ((*p).dx < 0) {
		(*p).inx = -1;
		(*p).dx = -(*p).dx;
	} else {
		(*p).inx = 0;
	}
	(*p).y = y1;
	(*p).dy = y2 - y1;
	if ((*p).dy > 0) {
		(*p).iny = 1;
	} else if ((*p).dy < 0) {
		(*p).iny = -1;
		(*p).dy = -(*p).dy;
	} else {
		(*p).iny = 0;
	}
	(*p).d = (*p).dy - (*p).dx;
	(*p).dx = __ASHL((*p).dx, 1);
	(*p).dy = __ASHL((*p).dy, 1);
}

static void LineStep__15 (LineParms__14 *p, LONGINT *p__typ)
{
	while ((*p).d < 0) {
		(*p).x += (*p).inx;
		(*p).d += (*p).dy;
	}
	(*p).drawX = (*p).x;
	(*p).drawY = __ASHR((*p).iny, 1) + (*p).y;
	(*p).d -= (*p).dx;
	(*p).y += (*p).iny;
}

static LONGINT Max4__17 (LONGINT a, LONGINT b, LONGINT c, LONGINT d)
{
	LONGINT m = 0;
	m = a;
	if (b > m) {
		m = b;
	}
	if (c > m) {
		m = c;
	}
	if (d > m) {
		m = d;
	}
	return m;
}

static LONGINT Min4__19 (LONGINT a, LONGINT b, LONGINT c, LONGINT d)
{
	LONGINT m = 0;
	m = a;
	if (b < m) {
		m = b;
	}
	if (c < m) {
		m = c;
	}
	if (d < m) {
		m = d;
	}
	return m;
}

void KeplerPorts_Port_FillQuad (KeplerPorts_Port P, INTEGER x1, INTEGER y1, INTEGER x2, INTEGER y2, INTEGER x3, INTEGER y3, INTEGER x4, INTEGER y4, INTEGER col, INTEGER pat, INTEGER mode)
{
	INTEGER x = 0, y = 0, RHS2 = 0, RHS3 = 0;
	LineParms__14 left = {0}, right = {0};
	struct FillQuad__11 _s;
	_s.lnk = FillQuad__11_s;
	FillQuad__11_s = &_s;
	x1 = __KeplerPorts_Port_CX(P, x1);
	x2 = __KeplerPorts_Port_CX(P, x2);
	x3 = __KeplerPorts_Port_CX(P, x3);
	x4 = __KeplerPorts_Port_CX(P, x4);
	y1 = __KeplerPorts_Port_CY(P, y1);
	y2 = __KeplerPorts_Port_CY(P, y2);
	y3 = __KeplerPorts_Port_CY(P, y3);
	y4 = __KeplerPorts_Port_CY(P, y4);
	if (((Max4__17(x1, x2, x3, x4) >= (LONGINT)P->X && Min4__19(x1, x2, x3, x4) <= (LONGINT)(P->X + P->W)) && Max4__17(y1, y2, y3, y4) >= (LONGINT)P->Y) && Min4__19(y1, y2, y3, y4) <= (LONGINT)(P->Y + P->H)) {
		if (y1 > y2 || y1 == y2 && x1 > x2) {
			x = x1;
			x1 = x2;
			x2 = x;
			y = y1;
			y1 = y2;
			y2 = y;
		}
		if (y2 > y3 || y2 == y3 && x2 > x3) {
			x = x2;
			x2 = x3;
			x3 = x;
			y = y2;
			y2 = y3;
			y3 = y;
		}
		if (y3 > y4 || y3 == y4 && x3 > x4) {
			x = x3;
			x3 = x4;
			x4 = x;
			y = y3;
			y3 = y4;
			y4 = y;
		}
		if (y1 > y2 || y1 == y2 && x1 > x2) {
			x = x1;
			x1 = x2;
			x2 = x;
			y = y1;
			y1 = y2;
			y2 = y;
		}
		if (y2 > y3 || y2 == y3 && x2 > x3) {
			x = x2;
			x2 = x3;
			x3 = x;
			y = y2;
			y2 = y3;
			y3 = y;
		}
		if (y1 > y2 || y1 == y2 && x1 > x2) {
			x = x1;
			x1 = x2;
			x2 = x;
			y = y1;
			y1 = y2;
			y2 = y;
		}
		if ((LONGINT)(x2 - x1) * (LONGINT)(y4 - y1) > (LONGINT)(y2 - y1) * (LONGINT)(x4 - x1)) {
			RHS2 = 2;
		} else {
			RHS2 = 0;
		}
		if ((LONGINT)(x3 - x1) * (LONGINT)(y4 - y1) > (LONGINT)(y3 - y1) * (LONGINT)(x4 - x1)) {
			RHS3 = 1;
		} else {
			RHS3 = 0;
		}
		switch (RHS2 + RHS3) {
			case 0: 
				InitLineParms__12(x1, y1, x2, y2, &left, LineParms__14__typ);
				InitLineParms__12(x1, y1, x4, y4, &right, LineParms__14__typ);
				break;
			case 1: 
				InitLineParms__12(x1, y1, x2, y2, &left, LineParms__14__typ);
				InitLineParms__12(x1, y1, x3, y3, &right, LineParms__14__typ);
				break;
			case 2: 
				InitLineParms__12(x1, y1, x3, y3, &left, LineParms__14__typ);
				InitLineParms__12(x1, y1, x2, y2, &right, LineParms__14__typ);
				break;
			case 3: 
				InitLineParms__12(x1, y1, x4, y4, &left, LineParms__14__typ);
				InitLineParms__12(x1, y1, x2, y2, &right, LineParms__14__typ);
				break;
			default: __CASECHK;
		}
		while (left.y != y2) {
			LineStep__15(&left, LineParms__14__typ);
			LineStep__15(&right, LineParms__14__typ);
			__KeplerPorts_Port_FillRect(P, __KeplerPorts_Port_Cx(P, left.drawX), __KeplerPorts_Port_Cy(P, left.drawY), __KeplerPorts_Port_Cx(P, right.drawX) - __KeplerPorts_Port_Cx(P, left.drawX), P->scale, col, pat, mode);
		}
		switch (RHS2 + RHS3) {
			case 0: 
				InitLineParms__12(x2, y2, x3, y3, &left, LineParms__14__typ);
				break;
			case 1: 
				InitLineParms__12(x2, y2, x4, y4, &left, LineParms__14__typ);
				break;
			case 2: 
				InitLineParms__12(x2, y2, x4, y4, &right, LineParms__14__typ);
				break;
			case 3: 
				InitLineParms__12(x2, y2, x3, y3, &right, LineParms__14__typ);
				break;
			default: __CASECHK;
		}
		while (left.y != y3) {
			LineStep__15(&left, LineParms__14__typ);
			LineStep__15(&right, LineParms__14__typ);
			__KeplerPorts_Port_FillRect(P, __KeplerPorts_Port_Cx(P, left.drawX), __KeplerPorts_Port_Cy(P, left.drawY), __KeplerPorts_Port_Cx(P, right.drawX) - __KeplerPorts_Port_Cx(P, left.drawX), P->scale, col, pat, mode);
		}
		switch (RHS2 + RHS3) {
			case 0: case 2: 
				InitLineParms__12(x3, y3, x4, y4, &left, LineParms__14__typ);
				break;
			case 1: case 3: 
				InitLineParms__12(x3, y3, x4, y4, &right, LineParms__14__typ);
				break;
			default: __CASECHK;
		}
		while (left.y != y4) {
			LineStep__15(&left, LineParms__14__typ);
			LineStep__15(&right, LineParms__14__typ);
			__KeplerPorts_Port_FillRect(P, __KeplerPorts_Port_Cx(P, left.drawX), __KeplerPorts_Port_Cy(P, left.drawY), __KeplerPorts_Port_Cx(P, right.drawX) - __KeplerPorts_Port_Cx(P, left.drawX), P->scale, col, pat, mode);
		}
	}
	FillQuad__11_s = _s.lnk;
}

void KeplerPorts_DisplayPort_DrawLine (KeplerPorts_DisplayPort P, INTEGER x1, INTEGER y1, INTEGER x2, INTEGER y2, INTEGER col, INTEGER mode)
{
	Display1_Line((void*)P, col, __KeplerPorts_Port_CX((void*)P, x1), __KeplerPorts_Port_CY((void*)P, y1), __KeplerPorts_Port_CX((void*)P, x2), __KeplerPorts_Port_CY((void*)P, y2), mode);
}

void KeplerPorts_DisplayPort_DrawCircle (KeplerPorts_DisplayPort P, INTEGER x, INTEGER y, INTEGER r, INTEGER col, INTEGER mode)
{
	Display1_Circle((void*)P, col, __KeplerPorts_Port_CX((void*)P, x), __KeplerPorts_Port_CY((void*)P, y), __DIV(r, P->scale), mode);
}

void KeplerPorts_DisplayPort_DrawEllipse (KeplerPorts_DisplayPort P, INTEGER x, INTEGER y, INTEGER a, INTEGER b, INTEGER col, INTEGER mode)
{
	Display1_Ellipse((void*)P, col, __KeplerPorts_Port_CX((void*)P, x), __KeplerPorts_Port_CY((void*)P, y), __DIV(a, P->scale), __DIV(b, P->scale), mode);
}

static BOOLEAN KeplerPorts_Intersect (KeplerPorts_Port F, INTEGER *X, INTEGER *Y, INTEGER *W, INTEGER *H)
{
	INTEGER t = 0;
	t = *X + *W;
	if (F->X > *X) {
		*X = F->X;
	}
	if (F->X + F->W < t) {
		*W = (F->X + F->W) - *X;
	} else {
		*W = t - *X;
	}
	if (*W <= 0) {
		return 0;
	}
	t = *Y + *H;
	if (F->Y > *Y) {
		*Y = F->Y;
	}
	if (F->Y + F->H < t) {
		*H = (F->Y + F->H) - *Y;
	} else {
		*H = t - *Y;
	}
	return *H > 0;
}

void KeplerPorts_DisplayPort_DrawString (KeplerPorts_DisplayPort P, INTEGER x, INTEGER y, CHAR *s, LONGINT s__len, Fonts_Font font, INTEGER col, INTEGER mode)
{
	CHAR ch = 0;
	LONGINT pat = 0;
	INTEGER X = 0, i = 0, dx = 0, chx = 0, chy = 0, chw = 0, chh = 0, Y = 0, oldX = 0, oldY = 0;
	SHORTINT fno = 0;
	__DUP(s, s__len, CHAR);
	fno = TextPrinter_FontNo(font);
	X = __KeplerPorts_Port_CX((void*)P, x);
	y = __KeplerPorts_Port_CY((void*)P, y);
	ch = s[0];
	i = 0;
	while (ch != 0x00) {
		Display_GetChar(font->raster, ch, &dx, &chx, &chy, &chw, &chh, &pat);
		Display_CopyPatternC((void*)P, col, pat, X + chx, y + chy, mode);
		x += (int)__DIVF(TextPrinter_DX(fno, ch), 3048);
		X = __KeplerPorts_Port_CX((void*)P, x + __ASHR(P->scale, 1));
		i += 1;
		ch = s[__X(i, s__len)];
	}
	__DEL(s);
}

void KeplerPorts_DisplayPort_FillRect (KeplerPorts_DisplayPort P, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER col, INTEGER pat, INTEGER mode)
{
	INTEGER xp = 0, yp = 0;
	x = __KeplerPorts_Port_CX((void*)P, x);
	y = __KeplerPorts_Port_CY((void*)P, y);
	w = __DIV(w, P->scale);
	h = __DIV(h, P->scale);
	xp = __KeplerPorts_Port_CX((void*)P, 0);
	yp = __KeplerPorts_Port_CY((void*)P, 0);
	if (pat == 5) {
		Display_ReplConstC((void*)P, col, x, y, w, h, mode);
	} else {
		Display_ReplPatternC((void*)P, col, Display1_ThisPattern(pat), x, y, w, h, xp, yp, mode);
	}
}

void KeplerPorts_PrinterPort_DrawLine (KeplerPorts_PrinterPort P, INTEGER x1, INTEGER y1, INTEGER x2, INTEGER y2, INTEGER col, INTEGER mode)
{
	x1 = __KeplerPorts_Port_CX((void*)P, x1);
	y1 = __KeplerPorts_Port_CY((void*)P, y1);
	x2 = __KeplerPorts_Port_CX((void*)P, x2);
	y2 = __KeplerPorts_Port_CY((void*)P, y2);
	Printer_Line(x1, y1, x2, y2);
}

void KeplerPorts_PrinterPort_DrawCircle (KeplerPorts_PrinterPort P, INTEGER x, INTEGER y, INTEGER r, INTEGER col, INTEGER mode)
{
	Printer_Circle(__KeplerPorts_Port_CX((void*)P, x), __KeplerPorts_Port_CY((void*)P, y), r);
}

void KeplerPorts_PrinterPort_DrawEllipse (KeplerPorts_PrinterPort P, INTEGER x, INTEGER y, INTEGER a, INTEGER b, INTEGER col, INTEGER mode)
{
	Printer_Ellipse(__KeplerPorts_Port_CX((void*)P, x), __KeplerPorts_Port_CY((void*)P, y), a, b);
}

void KeplerPorts_PrinterPort_DrawString (KeplerPorts_PrinterPort P, INTEGER x, INTEGER y, CHAR *s, LONGINT s__len, Fonts_Font font, INTEGER col, INTEGER mode)
{
	__DUP(s, s__len, CHAR);
	Printer_String(__KeplerPorts_Port_CX((void*)P, x), __KeplerPorts_Port_CY((void*)P, y), (void*)s, s__len, (void*)font->name, 32);
	__DEL(s);
}

void KeplerPorts_PrinterPort_FillRect (KeplerPorts_PrinterPort P, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER col, INTEGER pat, INTEGER mode)
{
	if (pat == 5) {
		Printer_ReplConst(__KeplerPorts_Port_CX((void*)P, x), __KeplerPorts_Port_CY((void*)P, y), w, h);
	} else {
		Printer_ReplPattern(__KeplerPorts_Port_CX((void*)P, x), __KeplerPorts_Port_CY((void*)P, y), w, h, pat);
	}
}

static void KeplerPorts_MinMax (INTEGER x, INTEGER y, INTEGER *min, INTEGER *max)
{
	if (x < y) {
		*min = x;
		*max = y;
	} else {
		*min = y;
		*max = x;
	}
}

static void KeplerPorts_BlowUp (KeplerPorts_Port P, INTEGER x, INTEGER y, INTEGER w, INTEGER h)
{
	x = x + P->x0;
	y = y + P->y0;
	if (x < P->X) {
		P->W = (P->W + P->X) - x;
		P->X = x;
	}
	if (x + w > P->X + P->W) {
		P->W = (x + w) - P->X;
	}
	if (y < P->Y) {
		P->H = (P->H + P->Y) - y;
		P->Y = y;
	}
	if (y + h > P->Y + P->H) {
		P->H = (y + h) - P->Y;
	}
}

void KeplerPorts_BalloonPort_DrawRect (KeplerPorts_BalloonPort P, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER col, INTEGER mode)
{
	KeplerPorts_Port_DrawRect((void*)P, x, y, w, h, col, mode);
}

void KeplerPorts_BalloonPort_DrawLine (KeplerPorts_BalloonPort P, INTEGER x1, INTEGER y1, INTEGER x2, INTEGER y2, INTEGER col, INTEGER mode)
{
	INTEGER minx = 0, miny = 0, maxx = 0, maxy = 0;
	KeplerPorts_MinMax(x1, x2, &minx, &maxx);
	KeplerPorts_MinMax(y1, y2, &miny, &maxy);
	KeplerPorts_BlowUp((void*)P, minx, miny, maxx - minx, maxy - miny);
}

void KeplerPorts_BalloonPort_DrawCircle (KeplerPorts_BalloonPort P, INTEGER x, INTEGER y, INTEGER r, INTEGER col, INTEGER mode)
{
	KeplerPorts_BlowUp((void*)P, (x - r) - 4, (y - r) - 4, __ASHL(r, 1) + 4, __ASHL(r, 1) + 4);
}

void KeplerPorts_BalloonPort_DrawEllipse (KeplerPorts_BalloonPort P, INTEGER x, INTEGER y, INTEGER a, INTEGER b, INTEGER col, INTEGER mode)
{
	KeplerPorts_BlowUp((void*)P, (x - a) - 4, (y - b) - 4, __ASHL(a, 1) + 4, __ASHL(b, 1) + 4);
}

INTEGER KeplerPorts_StringWidth (CHAR *s, LONGINT s__len, Fonts_Font f)
{
	SHORTINT fno = 0;
	CHAR ch = 0;
	INTEGER dx = 0, w = 0, i = 0, sdx = 0, sx = 0, sy = 0, sw = 0, sh = 0;
	LONGINT p = 0;
	fno = TextPrinter_FontNo(f);
	w = 0;
	i = 0;
	ch = s[0];
	while (ch != 0x00) {
		dx = (int)__DIVF(TextPrinter_DX(fno, ch), 3048);
		w += dx;
		i += 1;
		ch = s[__X(i, s__len)];
	}
	if (i > 0) {
		Display_GetChar(f->raster, s[__X(i - 1, s__len)], &sdx, &sx, &sy, &sw, &sh, &p);
		sdx = __ASHL(sdx, 2);
		if (sdx > dx) {
			w += sdx - dx;
		}
	}
	return w;
}

void KeplerPorts_BalloonPort_DrawString (KeplerPorts_BalloonPort P, INTEGER x, INTEGER y, CHAR *s, LONGINT s__len, Fonts_Font font, INTEGER col, INTEGER mode)
{
	__DUP(s, s__len, CHAR);
	KeplerPorts_BlowUp((void*)P, x, y + __ASHL(font->minY, 2), KeplerPorts_StringWidth((void*)s, s__len, font), __ASHL(font->height, 2));
	__DEL(s);
}

void KeplerPorts_BalloonPort_FillRect (KeplerPorts_BalloonPort P, INTEGER x, INTEGER y, INTEGER w, INTEGER h, INTEGER col, INTEGER pat, INTEGER mode)
{
	KeplerPorts_BlowUp((void*)P, x, y, w, h);
}

void KeplerPorts_BalloonPort_FillCircle (KeplerPorts_BalloonPort P, INTEGER x, INTEGER y, INTEGER r, INTEGER col, INTEGER pat, INTEGER mode)
{
	KeplerPorts_BlowUp((void*)P, (x - r) - 4, (y - r) - 4, __ASHL(r, 1) + 4, __ASHL(r, 1) + 4);
}

void KeplerPorts_BalloonPort_FillQuad (KeplerPorts_BalloonPort P, INTEGER x1, INTEGER y1, INTEGER x2, INTEGER y2, INTEGER x3, INTEGER y3, INTEGER x4, INTEGER y4, INTEGER col, INTEGER pat, INTEGER mode)
{
	KeplerPorts_MinMax(x1, x2, &x1, &x2);
	KeplerPorts_MinMax(x2, x3, &x2, &x3);
	KeplerPorts_MinMax(x3, x4, &x3, &x4);
	KeplerPorts_MinMax(x2, x3, &x2, &x3);
	KeplerPorts_MinMax(x1, x2, &x1, &x2);
	KeplerPorts_MinMax(y1, y2, &y1, &y2);
	KeplerPorts_MinMax(y2, y3, &y2, &y3);
	KeplerPorts_MinMax(y3, y4, &y3, &y4);
	KeplerPorts_MinMax(y2, y3, &y2, &y3);
	KeplerPorts_MinMax(y1, y2, &y1, &y2);
	KeplerPorts_BlowUp((void*)P, x1, y1, x4 - x1, y4 - y1);
}

void KeplerPorts_InitBalloon (KeplerPorts_BalloonPort P)
{
	P->scale = 1;
	P->X = 10000;
	P->Y = 10000;
	P->W = -20000;
	P->H = -20000;
}

__TDESC(KeplerPorts_PortDesc, 13, 3) = {__TDFLDS("PortDesc", 32), {0, 4, 28, -16}};
__TDESC(KeplerPorts_DisplayPortDesc, 13, 3) = {__TDFLDS("DisplayPortDesc", 32), {0, 4, 28, -16}};
__TDESC(KeplerPorts_PrinterPortDesc, 13, 3) = {__TDFLDS("PrinterPortDesc", 32), {0, 4, 28, -16}};
__TDESC(KeplerPorts_BalloonPortDesc, 13, 3) = {__TDFLDS("BalloonPortDesc", 32), {0, 4, 28, -16}};
__TDESC(LineParms__14, 1, 0) = {__TDFLDS("LineParms__14", 18), {-4}};

export void *KeplerPorts__init(void)
{
	__DEFMOD;
	__IMPORT(Display);
	__IMPORT(Display1);
	__IMPORT(Fonts);
	__IMPORT(Printer);
	__IMPORT(TextPrinter);
	__REGMOD(KeplerPorts, 0);
	__INITYP(KeplerPorts_PortDesc, Display_FrameDesc, 1);
	__INITBP(KeplerPorts_PortDesc, KeplerPorts_Port_CX, 0);
	__INITBP(KeplerPorts_PortDesc, KeplerPorts_Port_CY, 1);
	__INITBP(KeplerPorts_PortDesc, KeplerPorts_Port_Cx, 2);
	__INITBP(KeplerPorts_PortDesc, KeplerPorts_Port_Cy, 3);
	__INITBP(KeplerPorts_PortDesc, KeplerPorts_Port_DrawCircle, 4);
	__INITBP(KeplerPorts_PortDesc, KeplerPorts_Port_DrawEllipse, 5);
	__INITBP(KeplerPorts_PortDesc, KeplerPorts_Port_DrawLine, 6);
	__INITBP(KeplerPorts_PortDesc, KeplerPorts_Port_DrawRect, 7);
	__INITBP(KeplerPorts_PortDesc, KeplerPorts_Port_DrawString, 8);
	__INITBP(KeplerPorts_PortDesc, KeplerPorts_Port_FillCircle, 9);
	__INITBP(KeplerPorts_PortDesc, KeplerPorts_Port_FillQuad, 10);
	__INITBP(KeplerPorts_PortDesc, KeplerPorts_Port_FillRect, 11);
	__INITYP(KeplerPorts_DisplayPortDesc, KeplerPorts_PortDesc, 2);
	__INITBP(KeplerPorts_DisplayPortDesc, KeplerPorts_DisplayPort_DrawCircle, 4);
	__INITBP(KeplerPorts_DisplayPortDesc, KeplerPorts_DisplayPort_DrawEllipse, 5);
	__INITBP(KeplerPorts_DisplayPortDesc, KeplerPorts_DisplayPort_DrawLine, 6);
	__INITBP(KeplerPorts_DisplayPortDesc, KeplerPorts_DisplayPort_DrawString, 8);
	__INITBP(KeplerPorts_DisplayPortDesc, KeplerPorts_DisplayPort_FillRect, 11);
	__INITYP(KeplerPorts_PrinterPortDesc, KeplerPorts_PortDesc, 2);
	__INITBP(KeplerPorts_PrinterPortDesc, KeplerPorts_PrinterPort_DrawCircle, 4);
	__INITBP(KeplerPorts_PrinterPortDesc, KeplerPorts_PrinterPort_DrawEllipse, 5);
	__INITBP(KeplerPorts_PrinterPortDesc, KeplerPorts_PrinterPort_DrawLine, 6);
	__INITBP(KeplerPorts_PrinterPortDesc, KeplerPorts_PrinterPort_DrawString, 8);
	__INITBP(KeplerPorts_PrinterPortDesc, KeplerPorts_PrinterPort_FillRect, 11);
	__INITYP(KeplerPorts_BalloonPortDesc, KeplerPorts_PortDesc, 2);
	__INITBP(KeplerPorts_BalloonPortDesc, KeplerPorts_BalloonPort_DrawCircle, 4);
	__INITBP(KeplerPorts_BalloonPortDesc, KeplerPorts_BalloonPort_DrawEllipse, 5);
	__INITBP(KeplerPorts_BalloonPortDesc, KeplerPorts_BalloonPort_DrawLine, 6);
	__INITBP(KeplerPorts_BalloonPortDesc, KeplerPorts_BalloonPort_DrawRect, 7);
	__INITBP(KeplerPorts_BalloonPortDesc, KeplerPorts_BalloonPort_DrawString, 8);
	__INITBP(KeplerPorts_BalloonPortDesc, KeplerPorts_BalloonPort_FillCircle, 9);
	__INITBP(KeplerPorts_BalloonPortDesc, KeplerPorts_BalloonPort_FillQuad, 10);
	__INITBP(KeplerPorts_BalloonPortDesc, KeplerPorts_BalloonPort_FillRect, 11);
	__INITYP(LineParms__14, LineParms__14, 0);
/* BEGIN */
	__ENDMOD;
}
