/* Ofront 1.4 -xtspkaG */
#include "SYSTEM.h"
#include "DialogCheckBoxes.h"
#include "DialogFrames.h"
#include "DialogTexts.h"
#include "Dialogs.h"
#include "Oberon.h"
#include "TextFrames.h"
#include "Texts.h"


static Texts_Writer MyEdit_w;


export void MyEdit_Open (void);
export void MyEdit_Print (void);


void MyEdit_Open (void)
{
	INTEGER x = 0, y = 0;
	Dialogs_Panel p = NIL;
	Oberon_AllocateUserViewer(Oberon_Mouse.X, &x, &y);
	DialogFrames_OpenPanel((CHAR*)"Test.Dlg", (LONGINT)9, x, y, &p);
}

void MyEdit_Print (void)
{
	Dialogs_Object t = NIL, draft = NIL;
	Oberon_ParList par = NIL;
	INTEGER res = 0;
	Texts_Text t1 = NIL;
	Dialogs_Panel p = NIL;
	__NEW(par, Oberon_ParRec);
	par->text = TextFrames_Text((CHAR*)"", (LONGINT)1);
	par->vwr = Oberon_FocusViewer;
	par->frame = Oberon_Par->frame;
	p = Dialogs_cmdPanel;
	t = __Dialogs_Panel_NamedObject(p, (CHAR*)"file", (LONGINT)5);
	draft = __Dialogs_Panel_NamedObject(p, (CHAR*)"draft", (LONGINT)6);
	if (__ISP(t, DialogTexts_ItemDesc, 1)) {
		if (__ISP(draft, DialogCheckBoxes_ItemDesc, 1)) {
			if ((*(DialogCheckBoxes_Item*)&draft)->on) {
				Texts_WriteString(&MyEdit_w, Texts_Writer__typ, (CHAR*)"QuickDraw % ", (LONGINT)13);
			} else {
				Texts_WriteString(&MyEdit_w, Texts_Writer__typ, (CHAR*)"QuickDraw ", (LONGINT)11);
			}
			t1 = __DialogTexts_Item_GetText((*(DialogTexts_Item*)&t));
			Texts_Save(t1, 0, t1->len, MyEdit_w.buf);
			Texts_Append(par->text, MyEdit_w.buf);
			Oberon_Call((CHAR*)"Edit.Print", (LONGINT)11, par, 0, &res);
		}
	}
}

static void EnumPtrs(void (*P)(void*))
{
	__ENUMR(&MyEdit_w, Texts_Writer__typ, 36, 1, P);
}


export void *MyEdit__init(void)
{
	__DEFMOD;
	__IMPORT(DialogCheckBoxes);
	__IMPORT(DialogFrames);
	__IMPORT(DialogTexts);
	__IMPORT(Dialogs);
	__IMPORT(Oberon);
	__IMPORT(TextFrames);
	__IMPORT(Texts);
	__REGMOD(MyEdit, EnumPtrs);
	__REGCMD("Open", MyEdit_Open);
	__REGCMD("Print", MyEdit_Print);
/* BEGIN */
	Texts_OpenWriter(&MyEdit_w, Texts_Writer__typ);
	__ENDMOD;
}
