/* Ofront 1.4 -xtspkaG */

#ifndef PopupElems__h
#define PopupElems__h

#include "SYSTEM.h"
#include "Display.h"
#include "Texts.h"

typedef
	struct PopupElems_ElemDesc *PopupElems_Elem;

typedef
	struct PopupElems_ElemDesc { /* Texts_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[4];
		CHAR name[32];
		Texts_Text menu;
		BOOLEAN small;
		INTEGER n, default_;
		char _prvt2[4];
		SET options;
	} PopupElems_ElemDesc;

typedef
	struct PopupElems_ExecMsg { /* Texts_ElemMsg */
		Display_Frame frame;
		LONGINT pos;
		SET keys;
	} PopupElems_ExecMsg;



import LONGINT *PopupElems_ElemDesc__typ;
import LONGINT *PopupElems_ExecMsg__typ;

import void PopupElems_Alloc (void);
import void PopupElems_Handle (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ);
import void PopupElems_Insert (void);
import void PopupElems_InsertMenu (void);
import void PopupElems_MeasureMenu (PopupElems_Elem E);
import void PopupElems_Toggle (void);
import void PopupElems_Update (void);
import void *PopupElems__init(void);


#endif
