/* Ofront 1.4 -xtspkaG */

#ifndef TextFieldElems__h
#define TextFieldElems__h

#include "SYSTEM.h"
#include "Display.h"
#include "Elems.h"
#include "Texts.h"

typedef
	struct TextFieldElems_ElemDesc *TextFieldElems_Elem;

typedef
	struct TextFieldElems_ElemDesc { /* Elems_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[8];
		BOOLEAN locked;
		Texts_Text txt;
		SHORTINT maxLen;
	} TextFieldElems_ElemDesc;

typedef
	struct TextFieldElems_FrameDesc *TextFieldElems_Frame;

typedef
	struct TextFieldElems_FrameDesc { /* Display_FrameDesc */
		Display_Frame dsc, next;
		INTEGER X, Y, W, H;
		Display_Handler handle;
		TextFieldElems_Elem e;
	} TextFieldElems_FrameDesc;

typedef
	struct TextFieldElems_PWElemDesc *TextFieldElems_PWElem;

typedef
	struct TextFieldElems_PWElemDesc { /* TextFieldElems_ElemDesc */
		char _prvt0[20];
		LONGINT W, H;
		Texts_Handler handle;
		char _prvt1[8];
		BOOLEAN locked;
		Texts_Text txt;
		SHORTINT maxLen;
	} TextFieldElems_PWElemDesc;

typedef
	struct TextFieldElems_PWTextDesc *TextFieldElems_PWText;

typedef
	struct TextFieldElems_PWTextDesc { /* Texts_TextDesc */
		LONGINT len;
		Texts_Notifier notify;
		char _prvt0[12];
		Texts_Text hidden;
	} TextFieldElems_PWTextDesc;


import TextFieldElems_Elem TextFieldElems_curElem;

import LONGINT *TextFieldElems_ElemDesc__typ;
import LONGINT *TextFieldElems_PWElemDesc__typ;
import LONGINT *TextFieldElems_PWTextDesc__typ;
import LONGINT *TextFieldElems_FrameDesc__typ;

import TextFieldElems_PWText TextFieldElems_CopyPWText (TextFieldElems_PWText T);
import void TextFieldElems_Draw (TextFieldElems_Elem e, INTEGER x, INTEGER y, Display_Frame f);
import void TextFieldElems_FrameHandle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
import void TextFieldElems_Handle (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ);
import void TextFieldElems_HandlePW (Texts_Elem e, Texts_ElemMsg *msg, LONGINT *msg__typ);
import void TextFieldElems_Init (TextFieldElems_Elem e);
import void TextFieldElems_InitPW (TextFieldElems_PWElem e);
import void TextFieldElems_Insert (void);
import void TextFieldElems_InsertPW (void);
import void TextFieldElems_New (void);
import void TextFieldElems_NewPW (void);
import Display_Frame TextFieldElems_OpenFrame (TextFieldElems_Elem e, Display_Frame f, Display_Handler textHandler, Display_Handler frameHandler, INTEGER x, INTEGER y, INTEGER w, INTEGER h);
import void TextFieldElems_TextHandle (Display_Frame f, Display_FrameMsg *msg, LONGINT *msg__typ);
import void TextFieldElems_TextToString (Texts_Text t, CHAR *str, LONGINT str__len);
import void *TextFieldElems__init(void);


#endif
